   program

   map
      main
      AlanTelford(Long StartTime,Long EndTime,Short Increment,Byte Round),Short
      BrianStaff(Long StartTime,Long EndTime,Short Increment,Byte Round),Short
      CarlBarnes(Long StartTime,Long EndTime,Short Increment,Byte Round),Short
      DavidBayliss(Long StartTime,Long EndTime,Short Increment,Byte Round),Short
      GordonSmith(Long StartTime,Long EndTime,Short Increment,Byte Round),Short
      JeffSlarve(Long StartTime,Long EndTime,Short Increment,Byte Round),Short
      JohnCunningham(Long StartTime,Long EndTime,Short Increment,Byte Round),Short
      KurtPawlikowski(Long StartTime,Long EndTime,Short Increment,Byte Round),Short
      NikJohnsonA(Long StartTime,Long EndTime,Short Increment,Byte Round),Short
      NikJohnsonB(Long StartTime,Long EndTime,Short Increment,Byte Round),Short
      PeterGysegemA(LONG StartDate, LONG StartTime, LONG EndDate, LONG EndTime, SHORT Increment, BYTE RoundFlag),short
      !PeterGysegemB(LONG StartDate, LONG StartTime, LONG EndDate, LONG EndTime, SHORT Increment, BYTE RoundFlag),short
      PoulJensen(Long StartTime,Long EndTime,Short Increment,Byte Round),Short
   end



   code
   main()



main     procedure



    map
    end

Count       Long
Ending      Long
NextDay     long
RoundIt     Byte
Starting    Long
StartTime   long
ThisDay       long
Unit        Short
UnitCount   Short
x           short

ResultsQ    queue
Name           string(30)
Units          short
Elapsed        decimal(5,2)
Index          byte
            end

 
Window WINDOW('Time Tests (Thanks, Jeff)'),AT(,,249,205),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:ANSI), |
         CENTER,ICON('Clarion.ico'),GRAY,DOUBLE
       PROMPT('&Start Time:'),AT(4,8),USE(?Prompt1)
       SPIN(@t3),AT(56,8,60,10),USE(Starting),STEP(6000)
       PROMPT('&End Time:'),AT(128,8),USE(?Prompt2)
       SPIN(@t3),AT(172,8,60,10),USE(Ending),STEP(6000)
       PROMPT('&Unit Size:'),AT(4,24),USE(?Prompt3)
       SPIN(@n2),AT(56,24,60,10),USE(Unit),RANGE(1,60),STEP(1)
       CHECK('&Round'),AT(172,24),USE(RoundIt)
       PROMPT('No. Of Tests:'),AT(4,40),USE(?Prompt4)
       SPIN(@n9),AT(56,40,60,10),USE(Count)
       LIST,AT(4,56,240,128),USE(?List1),FORMAT('107L(2)|M~Name~@s30@43L(2)|M~Units~@n_6@20L(2)|M~Elapsed~@n5.2@'), |
           FROM(ResultsQ)
       BUTTON('&Calculate'),AT(56,188,45,14),USE(?Calculate),DEFAULT
       BUTTON('C&lose'),AT(148,188,45,14),USE(?Close),STD(std:close)
     END
 
 
   Code
   Starting = 5400001
   Ending = 5730001
   Unit = 15
   Count = 2000
   ThisDay = today()
   clear(ResultsQ)
   ResultsQ.Index = 1
   ResultsQ.Name = 'Alan Telford'
   add(ResultsQ)
   ResultsQ.Index = 2
   ResultsQ.Name = 'Brian Staff'
   add(ResultsQ)
   ResultsQ.Index = 3
   ResultsQ.Name = 'Carl Barnes'
   add(ResultsQ)
   ResultsQ.Index = 4
   ResultsQ.Name = 'David Bayliss'
   add(ResultsQ)
   ResultsQ.Index = 5
   ResultsQ.Name = 'Gordon Smith'
   add(ResultsQ)
   ResultsQ.Index = 6
   ResultsQ.Name = 'Jeff Slarve'
   add(ResultsQ)
   ResultsQ.Index = 7
   ResultsQ.Name = 'John Cunningham'
   add(ResultsQ)
   ResultsQ.Index = 8
   ResultsQ.Name = 'Kurt Pawlikowski'
   add(ResultsQ)
   ResultsQ.Index = 9
   ResultsQ.Name = 'Nik Johnson A'
   add(ResultsQ)
   ResultsQ.Index = 10
   ResultsQ.Name = 'Nik Johnson B'
   add(ResultsQ)
   ResultsQ.Index = 11
   ResultsQ.Name = 'Peter Gysegem A'
   add(ResultsQ)
   !ResultsQ.Index = 12
   !ResultsQ.Name = 'Peter Gysegem B'
   !add(ResultsQ)
   ResultsQ.Index = 13
   ResultsQ.Name = 'Poul Jensen'
   add(ResultsQ)
   Open(Window)
   post(event:accepted,?Calculate)
   Accept
      Case accepted()
      of ?Calculate
         setcursor(cursor:wait)
         if Ending > Starting
            NextDay = ThisDay
         else
            NextDay = ThisDay + 1
         end
         sort(ResultsQ,ResultsQ.Index)
         loop x = 1 to records(ResultsQ)
            get(ResultsQ,x)
            StartTime = clock()
            loop Count times
               execute x
                  ResultsQ.Units = AlanTelford(Starting,Ending,Unit,RoundIt)
                  ResultsQ.Units = BrianStaff(Starting,Ending,Unit,RoundIt)
                  ResultsQ.Units = CarlBarnes(Starting,Ending,Unit,RoundIt)
                  ResultsQ.Units = DavidBayliss(Starting,Ending,Unit,RoundIt)
                  ResultsQ.Units = GordonSmith(Starting,Ending,Unit,RoundIt)
                  ResultsQ.Units = JeffSlarve(Starting,Ending,Unit,RoundIt)
                  ResultsQ.Units = JohnCunningham(Starting,Ending,Unit,RoundIt)
                  ResultsQ.Units = KurtPawlikowski(Starting,Ending,Unit,RoundIt)
                  ResultsQ.Units = NikJohnsonA(Starting,Ending,Unit,RoundIt)
                  ResultsQ.Units = NikJohnsonB(Starting,Ending,Unit,RoundIt)
                  ResultsQ.Units = PeterGysegemA(ThisDay,Starting,NextDay,Ending,Unit,RoundIt)     !ResultsQ.Units = PeterGysegemB(ThisDay,Starting,NextDay,Ending,Unit,RoundIt)
                  ResultsQ.Units = PoulJensen(Starting,Ending,Unit,RoundIt)
               end
            end
            ResultsQ.Elapsed = (clock() - StartTime)/100
            put(ResultsQ)
         end
         sort(ResultsQ,ResultsQ.Elapsed)
         setcursor()
         display()
      end
   end
 
 

!-----------------------------------------------------------------------------!
JeffSlarve Procedure(Long StartTime,Long EndTime,Short Increment,Byte Round)
Result   Real
 
   Code
   Result   = ((EndTime - StartTime + Choose(StartTime > EndTime, 8640000, 1)) / Increment / 60) * .01
   Return     Choose(~Round,Result+Choose(~(Result-Int(Result)),0,1),Round(Result,1))
 

DavidBayliss procedure(s_time,e_time,incr,rnd)
dur long
   CODE
   dur = e_time-s_time
   IF dur < 0 THEN
     dur += 2 * 12 * 60 * 60 * 100
   .
   IF rnd
     RETURN ROUND(dur / incr / ( 60 * 100 ),1)
   ELSE
     dur /= incr * 60 * 100
     RETURN dur + 1
   END

!-----------------------------------------------------------------------------!
NikJohnsonA Procedure(Long T1,Long T2,Short B,Byte R)
Result DECIMAL(4)
  CODE
  Result = .5-R/2+(T2-T1-1+CHOOSE(T2-T1<1,8640000,0))/(B*6000)
  return(Result)

!-----------------------------------------------------------------------------!
NikJohnsonB Procedure(Long T1,Long T2,Short B,Byte R)
Result DECIMAL(4)
  CODE
  Result = ((((T2-T1)+CHOOSE((T2-T1)<0,8639999,-1))/B/3000)+1-R)/2
  return(Result)


!-----------------------------------------------------------------------------!
BrianStaff Procedure(Long T1,Long T2,Short Block,Byte Rounding)
X        LONG
Answer   long
   code
   X = CHOOSE(T2 > T1,(T2-1) - (T1-1),(T2-1) + (24*60*60*100) - (T1-1))
   EXECUTE(ROUNDING+1)
      Answer = ( X / (Block*60*100) ) + CHOOSE(X % (Block*60*100) = 0,0,1)
      Answer = ROUND( X / (Block*60*100), 1)
   END
   return(Answer)

!-----------------------------------------------------------------------------!
PoulJensen Procedure(Long LongStart,Long LongEnd,Short TimeBlock,Byte RoundIndicator)
TimeToBill              LONG
Blocks                     LONG
   code
   If Longstart > LongEnd
      TimeToBill = 8640001 - LongStart + LongEnd    
   else
      TimeToBill = LongEnd - LongStart   + 1                             
   End!if
   Blocks = Round((TimeToBill / TimeBlock/6000) ,1.0)                    
   If Not RoundIndicator and Blocks * TimeBlock * 6000 + 1 < TimeToBill
      Blocks +=1                                                         
   End!if
   return(Blocks)


!-----------------------------------------------------------------------------!
KurtPawlikowski Procedure(Long loc:StartTime,Long loc:EndTime,Short loc:Units,Byte loc:Round)
loc:UnitsBilled    long ! Result number of units billed
   code
   if loc:StartTime > loc:EndTime then loc:EndTime += 8640000.
   loc:UnitsBilled = int(((loc:EndTime - loc:StartTime)/(loc:Units * 6000))) |
     + ((((loc:EndTime - loc:StartTime)/(loc:Units * 3000))% 2) * loc:Round)
   return(loc:UnitsBilled)
 

!-----------------------------------------------------------------------------!
GordonSmith Procedure(Long b,Long e,Short u,Byte r)
a real, auto 
   code
   a = ((e - b + 8640000) % 8640000) / (u * 6000)
   return choose(r, round(a,  1), a + choose(a - int(a) > 0, 1, 0))


 
AlanTelford Function(Long p:StartTime, Long p:EndTime, Short p:BlockLength, Byte p:UseRounding)
! Return the number of blocks of time (of p:BlockLength minutes) which occur
! between p:StartTime and p:EndTime
! IF not rounding, then charge for each full or any part segment
! If rounding, then only charge for each full and any part segments which are as long as the block length
l:BlockCount  Short   ! return value from function
l:Minutes     Short   ! intermediate value which holds minutes between starttime and endtime
eMidnight     Equate(8640000)
  CODE
  ! If endtime is after midnight then add 24 hours so calculation comes out correct
  IF p:EndTime < p:StartTime
    p:EndTime += eMidnight
  END
  l:Minutes = (p:EndTime - p:StartTime) / 6000
  l:BlockCount = l:Minutes / p:BlockLength
  IF ~p:UseRounding and l:Minutes % p:BlockLength |
  OR l:Minutes % p:BlockLength >= p:BlockLength / 2
    l:BlockCount += 1
  END
  return l:BlockCount

 
PeterGysegemA      PROCEDURE  (LONG StartDate, LONG StartTime, LONG EndDate, LONG EndTime, SHORT Increment, BYTE RoundFlag) !
 
Elapsed  LONG   !Elapsed time in 100ths of a second
Ticks    LONG   !Billing increment in 100ths of a second
Units    SHORT  !Number of billing units
 
  CODE
  IF StartDate = EndDate
    Elapsed = EndTime - StartTime
  ELSE
    Elapsed = EndTime + 8640000 - StartTime
  END
  Ticks = Increment * 6000
 
  IF RoundFlag
    Units = ROUND(Elapsed/Ticks, 1)
  ELSE
    Units = Elapsed/Ticks
  END
 
  RETURN(Units)
 
 
!PeterGysegemB      PROCEDURE  (LONG StartDate, LONG StartTime, LONG EndDate, LONG EndTime, SHORT Increment, BYTE RoundFlag) !
!Elapsed  LONG   !Elapsed time in 100ths of a second
!Ticks    LONG   !Billing increment in 100ths of a second
!Units    SHORT  !Number of billing units
!   code
!   Elapsed = (EndTime - StartTime) + 8640000 * (EndDate - StartDate)
!   RETURN(CHOOSE(RoundFlag=0,INT(Elapsed/Increment*6000),ROUND(Elapsed/Increment*6000, 1)))
!

 
!-----------------------------------------------------------------------------!
JohnCunningham Procedure(Long TIM:timeStarted,Long TIM:TimeEnded,Short TIM:TimePeriod,Byte TIM:RoundedPeriod)
TIM:MinutesWorked    long
TIM:PeriodsWorked    short
   code
   Do CalcMinutes
   IF TIM:MinutesWorked % TIM:TimePeriod <> 0
    ! Left over minutes
    TIM:PeriodsWorked += 1
    IF TIM:RoundedPeriod
      ! Rounded
      IF (TIM:MinutesWorked % TIM:TimePeriod) < (TIM:TimePeriod / 2)
        ! Minimum of 1 period billed
        IF TIM:PeriodsWorked > 1
          TIM:PeriodsWorked -= 1
        END
      END
    END
  END
  return(TIM:PeriodsWorked)
 
CalcMinutes Routine
  IF TIM:TimeEnded >= TIM:TimeStarted
    ! Before Midnight
    TIM:MinutesWorked = ((TIM:TimeEnded-1)-(TIM:TimeStarted-1)+1)/6000
  ELSE
    ! After Midnight
    TIM:MinutesWorked = (((8640001-TIM:TimeStarted-1)+(TIM:TimeEnded-1))+1)/6000
  END
  TIM:PeriodsWorked = INT(TIM:MinutesWorked/TIM:TimePeriod)
 
 
 
!-----------------------------------------------------------------------------!
CarlBarnes Procedure(Long StartTime,Long StopTime,Short Period,Byte Roundit)
 
   CODE
   !ASSERT(Period = 0 )
   !ASSERT(RoundIt > 1)
   !RETURN INT((((StopTime - StartTime) / 6000 + 1440 ) % 1440 ) / Period + RoundIt / 2 )
   RETURN  (((StopTime - StartTime - 1) / 6000 + 1440 ) % 1440 ) / Period +1 - RoundIt / 2