#TEMPLATE( JS50Slider,'Sliders J & S Software Co. v5.0'),FAMILY('ABC'),FAMILY('CW20')
#!-------------------------------------------------------------------------
#! J & S Slider
#!-------------------------------------------------------------------------
#! (c) Copyright 1996/1997/1998/1999 J & S Software Co.  All Rights Reserved
#!-------------------------------------------------------------------------
#! 
#!-------------------------------------------------------------------------
#EXTENSION( SliderGlobal,'Slider Global Data and Methods '),APPLICATION
#SHEET
#TAB('Slider Global')
#BOXED('Slider v5.0')
#DISPLAY('This global extension adds the prototypes')
#DISPLAY('necessary for the slider controls to work.')
#DISPLAY('')
#DISPLAY('To use the slider control, populate the')
#DISPLAY('slider control template. ')
#ENDBOXED
#BOXED('Author')
#DISPLAY('Written by Jeff Slarve')
#DISPLAY('J && S Software Co.')
#DISPLAY('http://www.jssoftware.com')
#DISPLAY('This software was originally')
#DISPLAY('written by Jeff Slarve but ')
#DISPLAY('modified and extended by Andrew Guidroz II.')
#DISPLAY('All good points are Jeff''s, screwups ')
#DISPLAY('are all mine.')
#ENDBOXED
#DISPLAY('Copyright  1996,1997,1998,1999 J && S Software Co.')
#ENDTAB
#ENDSHEET
#AT(%CustomGlobalDeclarations)
 #PROJECT('jsslid50.clw')
#ENDAT
#AT(%GlobalData)
 include('jsslid50.inc')
#ENDAT
#!=====================================================================================
#CONTROL( VSliderControls, 'Vert Slider Controls'),REQ( SliderGlobal ), MULTI
  CONTROLS
       GROUP('Detail'),AT(,,32,103),USE(?JSGroup),BOXED
           PROMPT('More'),AT(7,11),USE(?JSMorePrompt)
           PANEL,AT(8,16,2,58),USE(?JSSlider),BEVEL(0,0,AADDH)
           REGION,AT(-6,25,13,7),USE(?JSSlideknob),FILL(Color:BtnFace),BEVEL(1,1)
           PROMPT('Less'),AT(-2,38),USE(?JSLessPrompt)
       END
  END
#! 5- Change bar to 0 outer & 0 inner with style of 43741, Height of 2 for horizontal and
#! Width of 3 for vertical. (Windows style) wuz 2,0,0600h
#!=====================================================================================
#INSERT(%JSSliderTemplateDialog)
#!=====================================================================================
#ATSTART
#DECLARE( %JSSliderType )
#SET(%JSSliderType, 'VSlider')
#INSERT(%JSSliderAtStart)
#ENDAT
#AT(%DataSectionBeforeWindow)
#INSERT(%JSSliderAtDataSectionBeforeWindow)
#ENDAT
#AT(%AfterWindowOpening)
#INSERT(%JSSliderAtAfterWindowOpening)
#ENDAT
#AT( %FieldCaseBeforeGenerated )
#INSERT(%JSSliderAtFieldCaseBeforeGenerated)
#ENDAT
#AT(%ProcedureRoutines)
#INSERT(%JSSliderAtProcedureRoutines),NOINDENT
#ENDAT
#AT(%EndofProcedure)
#INSERT(%JSSliderAtEndOfProcedureGroup)
#ENDAT
#!=====================================================================================
#CONTROL( HSliderControls, 'Horz Slider Controls'),REQ( SliderGlobal ), MULTI
  CONTROLS
       GROUP('Detail'),AT(,,155,32),USE(?JSGroup),BOXED
         PANEL,AT(30,18,88,2),USE(?JSSlider),BEVEL(0,0,AADDH)
         REGION,AT(39,-6,7,13),USE(?JSSlideknob),FILL(COLOR:BtnFace),BEVEL(1,1)
         PROMPT('Less'),AT(-63,2),USE(?JSLessPrompt)
         PROMPT('More'),AT(120,0),USE(?JSMorePrompt)
       END
  END
#! 5- Change bar to 0 outer & 0 inner with style of 43741, Height of 2 for horizontal and
#! Width of 3 for vertical. (Windows style) wuz 2,0,0600h
#!=====================================================================================
#INSERT(%JSSliderTemplateDialog)
#!=====================================================================================
#ATSTART
#DECLARE( %JSSliderType )
#SET(%JSSliderType, 'HSlider')
#INSERT(%JSSliderAtStart)
#ENDAT
#AT(%DataSectionBeforeWindow)
#INSERT(%JSSliderAtDataSectionBeforeWindow)
#ENDAT
#AT(%AfterWindowOpening)
#INSERT(%JSSliderAtAfterWindowOpening)
#ENDAT
#AT( %FieldCaseBeforeGenerated )
#INSERT(%JSSliderAtFieldCaseBeforeGenerated)
#ENDAT
#AT(%ProcedureRoutines)
#INSERT(%JSSliderAtProcedureRoutines),NOINDENT
#ENDAT
#AT(%EndofProcedure)
#INSERT(%JSSliderAtEndOfProcedureGroup)
#ENDAT
#!=====================================================================================
#GROUP(%JSSliderTemplateDialog)
#SHEET
#TAB('Slider Prompts')
#PROMPT('Field to Use:', FIELD),%JSSliderUse
#BOXED('Tabbed window')
    #PROMPT('Use slider for tabbing',CHECK),%JSTabbing,DEFAULT(0)
    #ENABLE(%JSTabbing<>0)
        #PROMPT('Sheet control for wizard slider:',Control),%JSSheetControl
        #PREPARE
            #FIX(%Control,%JSSheetControl)
        #ENDPREPARE
        #VALIDATE(CLIP(%ControlType)='SHEET','Sheet control must be type Sheet!' & %ControlType)
    #ENDENABLE
#ENDBOXED
#ENABLE(%JSTabbing=0)
    #BOXED('Range information')
        #PROMPT('Maximum Range:', @n_10.2 ),%JSMaxRange
        #PROMPT('Minimum Range:', @n_10.2 ),%JSMinRange,DEFAULT(0)
        #VALIDATE(%JSMinRange < %JSMaxRange, 'Minimum Range must be less than Maximum Range.')
    #ENDBOXED
    #PROMPT('Graduations:', SPIN(@n3,0,10000)),%JSGrads,DEFAULT(0)
    #VALIDATE(%JSGrads<>1,'If graduations are desired, it should be set to at least 2')
    #PREPARE
        #IF(%JSGrads=1)
            #SET(%JSGrads,2)
        #ENDIF
    #ENDPREPARE
#ENDENABLE
#ENABLE(%JSGrads<>0)
  #BOXED('Graduation settings')
     #ENABLE(%JSTabbing=0)
        #PROMPT('Lock to graduations',CHECK),%JSTickLock,DEFAULT(0)
     #ENDENABLE
     #PROMPT('Show top/left graduations',CHECK),%JSTopLeftTicks,DEFAULT(1)
     #PROMPT('Show bottom/right grads',CHECK),%JSBottomRightTicks,DEFAULT(1)
     #PROMPT('Size of graduations:', SPIN(@n3,0,20)),%JSTickSize,DEFAULT(5)
  #ENDBOXED
#ENDENABLE
#ENABLE(%JSTabbing=0)
    #BOXED('Scrolling')
        #DISPLAY('The smallest scroll size:  ' & '          ' & %JSSmallestGrad)
        #PROMPT('Large Scroll:', @n_10.2),%JSLargeScroll
        #PREPARE
        #DECLARE(%JSSmallestGrad,REAL)
            #IF(%JSGrads <> 0)
                #SET(%JSSmallestGrad,(%JSMaxRange - %JSMinRange) / (%JSGrads - 1))
                #IF((%JSLargeScroll=0) OR ((%JSSmallestGrad % %JSLargeScroll) <> 0) OR (%JSSmallestGrad > %JSLargeScroll))
                    #SET(%JSLargeScroll,%JSSmallestGrad)
                #ENDIF
                #IF((%JSSmallScroll=0) OR ((%JSSmallestGrad % %JSSmallScroll) <> 0) OR (%JSSmallestGrad > %JSSmallScroll) OR (%JSSmallScroll > %JSLargeScroll))
                    #SET(%JSSmallScroll,%JSSmallestGrad)
                #ENDIF
            #ENDIF
        #ENDPREPARE
        #PROMPT('Small Scroll:', @n_10.2),%JSSmallScroll,DEFAULT(((%JSMaxRange - %JSMinRange) + 1) / %JSGrads)
    #ENDBOXED
#ENDENABLE
#PROMPT('Auto Adjust Size', CHECK),%JSAutoAdjust,DEFAULT(1)
#PROMPT('MSG:', @s100),%JSMSG
#PROMPT('ToolTip:',@s100),%JSToolTip
#BOXED('Only if the slider is on a TOOLBAR'), WHERE(%ControlTool)
#DISPLAY('Since the  slider is on a toolbar, you need to ')
#DISPLAY('populate a GROUP control on the toolbar to ')
#DISPLAY('serve as the PARENT. ')
#DISPLAY('Simply populate the GROUP, set the size to zero ')
#DISPLAY('height and zero width, then enter the control in ')
#DISPLAY('this prompt.')
#PROMPT('Parent Control:', FROM( %Control, %ControlType = 'GROUP')),%JSSlideParent
#ENDBOXED
#ENDTAB
#ENDSHEET
#!=====================================================================================
#GROUP(%JSSliderAtStart)
#DECLARE( %JSParent )
#DECLARE( %JSSlider )
#DECLARE( %JSSlideKnob )
  #FOR(%Control),WHERE(%ControlInstance=%ActiveTemplateInstance)
    #CASE(%ControlOriginal)
    #OF('?JSSlider')
        #SET( %JSSlider, %Control )
        #IF(~%ControlTool)
          #SET(%JSParent, %JSSlider & '{{PROP:Parent}')
        #ELSE
          #SET(%JSParent, %JSSLideParent )
        #ENDIF
    #OF('?JSSlideknob')
        #SET( %JSSlideKnob, %Control )
    #ENDCASE
  #ENDFOR
#!=====================================================================================
#GROUP(%JSSliderAtDataSectionBeforeWindow)
  #FOR(%Control),WHERE(%ControlInstance=%ActiveTemplateInstance)
    #CASE(%ControlOriginal)
    #OF('?JSSlideknob')
JSSliderInit%ActiveTemplateInstance       Like(JSSIG) !Group for initializing the slider control
JSSlider:%ActiveTemplateInstance &%JSSliderType:Class
    #ENDCASE
  #ENDFOR
#!=====================================================================================
#GROUP(%JSSliderAtAfterWindowOpening)
 Do %JSSliderType:Init::%ActiveTemplateInstance
#!=====================================================================================
#GROUP(%JSSliderAtFieldCaseBeforeGenerated)
  #FOR(%Control),WHERE(%ControlInstance=%ActiveTemplateInstance)
    #CASE(%ControlOriginal)
    #OF('?JSSlideknob')
 of JSSlider:%ActiveTemplateInstance.Field()
  IF JSSlider:%ActiveTemplateInstance.EventHandler(%JSSliderUse)
#IF(%JSTabbing<>0)
    UPDATE
    DISPLAY
    SELECT(%JSSheetControl,%JSSliderUse)
    SELECT(%JSSlideKnob)
#ENDIF
  END
    #ENDCASE
  #ENDFOR
#!=====================================================================================
#GROUP(%JSSliderAtProcedureRoutines)
%JSSliderType:Init::%ActiveTemplateInstance Routine
 Clear( JSSliderInit%ActiveTemplateInstance )
 JSSlider:%ActiveTemplateInstance &= NEW %JSSliderType:Class
 JSSliderInit%ActiveTemplateInstance.SliderCTL = %JSSlider
 JSSliderInit%ActiveTemplateInstance.KnobCTL = %JSSlideKnob
 JSSliderInit%ActiveTemplateInstance.Parent =  %JSParent
 JSSliderInit%ActiveTemplateInstance.KnobSize = 0
 JSSliderInit%ActiveTemplateInstance.TopLeftTicks = %JSTopLeftTicks
 JSSliderInit%ActiveTemplateInstance.BottomRightTicks = %JSBottomRightTicks
 JSSliderInit%ActiveTemplateInstance.GradSize = %JSTickSize
 JSSliderInit%ActiveTemplateInstance.AdjustOK = %JSAutoAdjust
 JSSliderInit%ActiveTemplateInstance.ToolTip = '%JSToolTip'
 JSSliderInit%ActiveTemplateInstance.MSG = '%JSMSG'
#IF(%JSTabbing<>0)
 JSSliderInit%ActiveTemplateInstance.Graduations = %JSSheetControl{PROP:NumTabs}
 JSSliderInit%ActiveTemplateInstance.TickLock = TRUE
 JSSliderInit%ActiveTemplateInstance.LargeScroll = 1
 JSSliderInit%ActiveTemplateInstance.SmallScroll = 1
 JSSliderInit%ActiveTemplateInstance.SheetControl = %JSSheetControl
 JSSlider:%ActiveTemplateInstance.init( %JSSLiderUse, JSSliderInit%ActiveTemplateInstance.Graduations, 1, JSSliderInit%ActiveTemplateInstance )
#ELSE
 JSSliderInit%ActiveTemplateInstance.Graduations = %JSGrads
 JSSliderInit%ActiveTemplateInstance.TickLock = %JSTickLock
 JSSliderInit%ActiveTemplateInstance.LargeScroll = %JSLargeScroll
 JSSliderInit%ActiveTemplateInstance.SmallScroll = %JSSmallScroll
 JSSliderInit%ActiveTemplateInstance.SheetControl = 0
 JSSlider:%ActiveTemplateInstance.init( %JSSLiderUse, %JSMaxRange, %JSMinRange, JSSliderInit%ActiveTemplateInstance )
#ENDIF
#!=====================================================================================
#GROUP(%JSSliderAtEndOfProcedureGroup)
  #FOR(%Control),WHERE(%ControlInstance=%ActiveTemplateInstance)
    #CASE(%ControlOriginal)
    #OF('?JSSlider')
  JSSlider:%ActiveTemplateInstance.kill()
  Dispose( JSSlider:%ActiveTemplateInstance )
    #ENDCASE
  #ENDFOR
#!=====================================================================================
